var param = {
    B2B_SALE : {
        name : '商品列表',
        extraInfo : {
            ShowProdSearch : true,
        }
    },
    B2B_SALE_BY_BAR : {
        name : '商品条码检索',
    },
    B2B_SALE_HOT : {
        name : '热销药品',
        extraInfo : {
            Category : true,
            noAllCategory : true
        }
    },
    /*B2B_SALE_NEW : {
     name : '新品'
     },*/
    B2B_SALE_XPZS : {
        name : '新品'
    },
    B2B_SALE_YDCB : {
        name : '药店常备'
    },
    B2B_SALE_HISTORY : {
        name : '历史采购',
        extraInfo : {
            popProdSearch : true,
            Category : true
        }
    },
    B2B_COLLECT : {
        name : '我的关注',
        extraInfo : {
            edit : true
        }
    },
    B2B_SALE_ANGENT : {
        name : '总代品种',
        extraInfo : {
            ProdSearch : true,
            AgentProd : true,
            showmodel : 1
        }
    },
    B2B_SALE_ZY : {
        name : '中药',
        extraInfo : {
            ProdSearch : true,
            ZYProd : true,
            showmodel : 1
        }
    },
    B2B_SALE_QX : {
        name : '器械',
        extraInfo : {
            ProdSearch : true,
            showmodel : 1
        }
    },
    B2B_SALE_ZXH : {
        name : '展销会品种',
        extraInfo : {
            ProdSearch : true,
           
        }
    },
    B2B_SALE_CJZXH : {
        name : '展销会厂家品种',
        extraInfo : {
            ProdSearch : true,
            nomanufactsort : true,
            QRCodeScanner : true,
        }
    },
    B2B_MANUFACT_SALE : {
        name : '推荐厂家品种',
        extraInfo : {
            nomanufactsort : true
        }
    },
    B2B_RECOMMEND_SALE : {
        name : '本周主推',
        extraInfo : {
            noSort : true,
            showmodel : 1
        }
    },
    B2B_ACTIVITY : {
        name : '活动',
        extraInfo : {
            noSort : true,
            interval : true
        }
    },
    B2B_RECOMMEND_PUR : {
        name : '采购推荐',
        extraInfo : {
            RecommendPur : true,
            ProdSearch : true,
            noSort : true
        }
    }
},
    currentSortTab = 0;

//排序选项卡 数据加载  事件处理
var addSortTabs = function(nomanufactsort, showmodel) {
    var sort = '<div><input name="sort" type=\"checkbox\" class=\"uhide\"/><div class=\"sort\"><div class=\"default\"></div><div class="split"></div><div class=\"checked\"></div></div>';
    var data = [{
        label : "<div>默认"
    }, {
        label : sort + '价格'
    }, {
        label : '<div name="self"><input id="showmodel" ' + ( showmodel ? 'checked="true"' : '') + ' type=\"checkbox\" class=\"uhide\"/><div class=\"display\"><div class=\"checked fa fa-list-ul\">列表</div><div class=\"default fa fa-th-large\">大图</div></div></label>'
    }];
    if (!nomanufactsort) {
        data.push({
            label : sort + '厂家'
        });
    }

    var tabview = appcan.tab({
        selector : "#sortTabs",
        hasIcon : false,
        hasAnim : false,
        hasLabel : true,
        hasBadge : false,
        index : 0,
        data : data
    });

    var sortInterval = setInterval(function() {
        if ($('#sortTabs .sc-text-tab').length > 0) {
            $('#sortTabs .sc-text-tab').removeClass('ub-ver');
            clearInterval(sortInterval);
        }
    }, 20);

    tabview.on("click", function(obj, index) {
        if (index == 1 || index == 2 || index == 3) {
            var box = obj.find('input')[0];
            box.checked = !box.checked;
        }

        if (currentSortTab != index) {
            //前一次有排序格则的需关闭规则
            if ((currentSortTab == 3 || currentSortTab == 1) && index != 2 || (currentSortTab == 1 && index == 2)) {
                var checkbox = $('[isSwitch]');
                if (checkbox.length > 0) {
                    $.each(checkbox, function(index, item) {
                        item.checked = false;
                    });
                    checkbox.removeAttr('isSwitch');
                    checkbox.parents('.sc-text-tab').removeClass('sc-text-active');
                }
            }
            //由于是本机排序，排序完后切换图表模式，需要将选项卡置为默认
            if (index == 2 && currentSortTab == 1) {
                obj.parents('.tab_l').find('[data-index="0"]').find('.sc-text-tab').addClass('sc-text-active');
            }

            //初次点击价格和厂家排序，需要激活开关设置
            if (index == 1 || index == 3) {
                obj.find('input').attr('isSwitch', 'true');
            }
            currentSortTab = index;
        }

        if (index == 0) {
            var param = {};
            param.priceToSort = '';
            param.manufacturerToSort = '';
            appcan.frame.evaluateScript({
                name : '',
                popName : 'content',
                scriptContent : 'resetPage(' + JSON.stringify(param) + ');'
            });
        }
        //价格排序
        else if (index == 1) {
            var sort = obj.find('input:checked').length;
            if (pageParam.method == 'B2B_SALE_ANGENT') {
                var param = {};
                param.priceToSort = (sort == 0 ? 'asc' : 'desc');
                param.manufacturerToSort = '';
                appcan.frame.evaluateScript({
                    name : 'ProdList',
                    popName : 'content',
                    scriptContent : 'resetPage(' + JSON.stringify(param) + ');'
                });
            } else {
                loading.show('加载中…');
                appcan.frame.evaluateScript({
                    name : '',
                    popName : 'content',
                    scriptContent : 'switchSort("memberPrice",' + sort + ');appcan.window.evaluateScript({name : "",scriptContent : "loading.hide();"});toast.show("页面数据排序完成！", 1500);'
                });
            }
        }
        //列表与大图切换
        else if (index == 2) {
            loading.show('切换模式中…');
            var model = obj.find('input:checked').length;
            appcan.frame.evaluateScript({
                name : '',
                popName : 'content',
                scriptContent : 'switchShowModel(' + model + ');appcan.window.evaluateScript({name : "",scriptContent : "loading.hide();"});'
            });
        }
        //厂家排序
        else if (index == 3) {
            var sort = obj.find('input:checked').length;
            var param = {};
            param.priceToSort = '';
            param.manufacturerToSort = (sort == 0 ? 'asc' : 'desc');
            appcan.frame.evaluateScript({
                name : '',
                popName : 'content',
                scriptContent : 'resetPage(' + JSON.stringify(param) + ');'
            });
        }

        if (!isPhone) {
            if (currentSortTab == index) {
                return;
            }
        }
    });
}
var resetShowSortTabs = function() {
    //重置商品的排序选项卡
    var switchCon = $('#sortTabs [name="sort"][isSwitch]');
    switchCon.parents('.sc-text-tab').removeClass('sc-text-active');
    switchCon.removeAttr('isSwitch');
    $('#sortTabs').find('[data-index="0"]').find('.sc-text-tab').addClass('sc-text-active');
}
/*页头查询按钮 添加及事件处理*/
var addSearchBtn = function() {
    $('#btn_search').addClass('nav-btn').append($('<div class="fa fa-search" style="font-size: 1.25em;"></div>'));

    appcan.button("#btn_search", "btn-act", function() {
        //不使用公共方法，公共方法打开从右切入，弹出框不适用
        appcan.frame.open({
            id : 'PopoverProdSearch',
            url : 'PopoverProdSearch.html',
            dataType : 0,
            left : '0',
            top : '0',
        });
    });
}
/*页头编辑按钮 添加及事件处理*/
var addEditBtn = function() {
    $('#btn_edit').addClass('nav-btn').html('编辑');
    appcan.button("#btn_edit", "btn-act", function() {
        var text,
            editModel;
        if ($(this).html() == '编辑') {
            text = '取消';
            editModel = 1;
        } else {
            text = '编辑';
            editModel = 0;
        }
        $(this).html(text);

        //展示删除和全选控件，调整浮动页窗体大小
        $('#footer_collect').toggleClass('uhide');
        var titHeight = $('#content').offset().top + 1;
        appcan.frame.resize({
            id : 'content',
            left : 0,
            top : titHeight
        });

        appcan.frame.evaluateScript({
            name : 'ProdList',
            popName : 'content',
            scriptContent : 'EditPage(' + editModel + ');'
        });
    });

    //全选和反选控制
    $('#changeAll').bind('change', function() {
        var checked = $(this)[0].checked;
        $('#choicetext').html( checked ? '反选' : '全选');
        appcan.frame.evaluateScript({
            name : 'ProdList',
            popName : 'content',
            scriptContent : '$.each($("input[type=checkbox]"),function(index,item){item.checked=' + checked + '});'
        });
    });

    //删除已选
    appcan.button("#cancelCollect", "btn-act", function() {
        appcan.frame.evaluateScript({
            name : 'ProdList',
            popName : 'content',
            scriptContent : 'loading.show();deleteChoice();'
        });
    });

}
/*商品输入搜索*/
var addProdSearch = function() {
    $('#prodsearch').removeClass('uhide');
    window.Change_prod = function(data) {
        var param = {
            keyWord : $('#prod').val()
        };
        appcan.frame.evaluateScript({
            name : 'ProdList',
            popName : 'content',
            scriptContent : 'resetPage(' + JSON.stringify(param) + ');'
        });
    }
}
var addShowProdSearch = function() {
    $('#showprodsearch input').val(pageParam.keyword || '');
    $('#showprodsearch').removeClass('uhide');
    $('#showprodsearch').bind(touch, function() {
        appcan.window.open({
            name : 'ProdSearch_EC',
            data : 'ProdSearch_EC.html',
            type : 0
        });
    });
}
/**
 *总代理商品 类别 选项卡 加载事件处理
 */
var addAgentClassifyTab = function() {
    var data = [{
        label : "全部",
        category : ''
    }, {
        label : "连锁专属",
        category : 2
    }, {
        label : "商业分销",
        category : 1
    }];
    renderClassifyTab(data);
}
/**
 *中药商品 类别 选项卡 加载事件处理
 */
var addZYClassifyTab = function() {
    var data = [{
        label : "全部",
        category : '20'
    }, {
        label : "爆款推荐",
        category : '2001'
    }, {
        label : "参茸贵细",
        category : '2002'
    }, {
        label : "传统滋补",
        category : '2003'
    }, {
        label : "营养食补",
        category : '2004'
    }, {
        label : "其他滋补",
        category : '2005'
    }, {
        label : "抓方饮片",
        category : '2006'
    }];

    $('#ClassifyTabs').addClass('zy_tab');
    renderClassifyTab(data);
}
/**
 *采购推荐   类别 选项卡加载事件处理
 */
var addRecommendTab = function() {
    var data = [{
        label : "综合",
    }, {
        label : "猜你喜欢",
    }, {
        label : "大家都在买",
    }];

    renderClassifyTab(data);
}
/**
 *扫描客户的二维码 按钮,  选择客户
 */
var addQRCodeScanner = function() {
    uexScanner.cbOpen = function(opCode, dataType, data) {
        var obj = eval('(' + data + ')');
        successScanner(obj);
    };
    $('#btn_scanner').removeClass('uhide').bind('click', function() {
        if (isPhone) {
            uexScanner.open();
        } else {
            var data = {
                code : 'supplierCustId|711280001,custId|38032,custName|湖北富迪实业有限公司,danwBh|B429004001X002HA,danwNm|DWI00143076,branchId|J55',
            }
            successScanner(data);
        }
    });
}
var successScanner = function(result) {
    var obj = result.code;
    var params = obj.split(',');
    var custObj = {};
    $.each(params, function(index, item) {
        var para = item.split('|');
        if (para.length > 1) {
            custObj[para[0]] = para[1] || null;
        }
    });
    if (!custObj.supplierCustId) {
        alert('该客户无法识别！');
        return;
    }
    if (custObj.custId && custObj.custName && custObj.branchId && custObj.danwBh && custObj.danwNm) {
        AjaxFn(urls.OUTSIDE_CHECK_CUST, custObj, function(result) {
            if (result.success) {
                AjaxFn(urls.OUTSIDE_CHECKLICENSE, {
                    danwNm : custObj.danwNm                   
                }, function(result) {
                    if (result.checkFlag == 1) {
                        LocStorage.set('chooseCust', JSON.stringify(custObj));
                        uexWindow.evaluateMultiPopoverScript('OutsideBusinessApp', 'content', 'content_0', 'setCust();');
                        appcan.window.evaluatePopoverScript('ProdList', 'content', 'toast.show("已为您选择该客户", 2000);setTimeout("page = 1;initPage();",200);');
                    } else if (result.checkFlag == -3) {
                        appcan.window.confirm({
                            title : '注意',
                            content : '该客户证照即将过期，确定继续选择该客户？',
                            buttons : ['确定', '取消'],
                            callback : function(err, data, dataType, optId) {
                                if (err) {
                                    alert('确认框发生错误！');
                                    return;
                                }
                                if (data == 0) {
                                    LocStorage.set('chooseCust', JSON.stringify(custObj));                                                                        
                                    uexWindow.evaluateMultiPopoverScript('OutsideBusinessApp', 'content', 'content_0', 'setCust();');
                                    appcan.window.evaluatePopoverScript('ProdList', 'content', 'toast.show("已为您选择该客户", 2000);setTimeout("page = 1;initPage();",200);');
                                }
                            }
                        });
                    } else {
                        alert(result.msg || '该客户证照异常，无法选择该客户！');
                    }
                });
            }
        });
    } else {
        alert('该二维码不是有效的客户信息二维码！');
    }
}
/**
 *类别 选项卡 加载事件处理
 */
var renderClassifyTab = function(data) {
    var renderClassifyTab = appcan.tab({
        selector : "#ClassifyTabs",
        hasIcon : false,
        hasAnim : true,
        hasLabel : true,
        hasBadge : false,
        index : 0,
        data : data
    });

    var agentInterval = setInterval(function() {
        if ($('#ClassifyTabs .sc-text-tab').length > 0) {
            $('#ClassifyTabs .sc-text-tab').removeClass('ub-ver');
            clearInterval(agentInterval);

            if ($('#ClassifyTabs').hasClass('zy_tab')) {
                var tabs = $('#ClassifyTabs .sc-text-tab div');
                var width = $(tabs[0]).width(),
                    fontSize = parseInt(document.defaultView.getComputedStyle(tabs[0], null).fontSize);
                if (width > fontSize * 2 && width < fontSize * 4) {
                    var padding = (width - fontSize * 2.8) / 2;
                    tabs.css({
                        width : width + 'px',
                        padding : '0 ' + padding + 'px'
                    })
                }

            }
        }
    }, 20);

    renderClassifyTab.on("click", function(obj, index, data) {
        resetShowSortTabs();
        var param = {
            priceToSort : '',
            manufacturerToSort : ''
        };
        param.category = data.category;
        appcan.frame.evaluateScript({
            name : 'ProdList',
            popName : 'content',
            scriptContent : 'resetPage(' + JSON.stringify(param) + ');'
        });
    });
}
/**
 *商品类别选项卡 类别 加载事件处理
 */
var addCategoryTabs = function(noAllCategory) {
    var data = [{
        label : "<div value='西药'>西药</div>"
    }, {
        label : "<div value='中药产品'>中药</div>"
    }, {
        label : "<div value='医疗器械'>器械</div>"
    }, {
        label : "<div value='计生用品'>计生</div>"
    }, /*{
     label : "<div value='非药产品'>非药</div>"
     }, */
    {
        label : "<div value='其它'>其它</div>"
    }];
    if (!noAllCategory) {
        data.splice(0, 0, {
            label : "<div value=''>全部</div>"
        });
    }
    var categoryTabs = appcan.tab({
        selector : "#categoryTabs",
        hasIcon : false,
        hasAnim : true,
        hasLabel : true,
        hasBadge : false,
        index : 0,
        data : data
    });
    var categoryInterval = setInterval(function() {
        if ($('#categoryTabs .sc-text-tab').length > 0) {
            $('#categoryTabs .sc-text-tab').removeClass('ub-ver');
            clearInterval(categoryInterval);
        }
    }, 20);
    categoryTabs.on("click", function(obj, index) {
        var param = {
            category : obj.find('div [value]').attr('value')
        };
        appcan.frame.evaluateScript({
            name : 'ProdList',
            popName : 'content',
            scriptContent : 'resetPage(' + JSON.stringify(param) + ');'
        });
    });
}
//添加活动计时器
var addInterval = function() {
    $('<div id="interval" class="uinn2">&nbsp;</div><div id="interval-split" class="h-split"></div>').insertBefore($('#content'));
}
var activityInterval,
    i = 0;
//设置活动计时器时间
var setShowInterval = function(activityIsStart, activityTime, activityMsg) {
    if (activityInterval) {
        clearInterval(activityInterval);
    }
    var show = function(time) {
        var convertTime = function(shijiancha) {
            if (shijiancha > 0) {

                var days = shijiancha / 1000 / 60 / 60 / 24;
                var daysRound = Math.floor(days);
                var hours = shijiancha / 1000 / 60 / 60 - (24 * daysRound);
                var hoursRound = Math.floor(hours);
                var minutes = shijiancha / 1000 / 60 - (24 * 60 * daysRound) - (60 * hoursRound);
                var minutesRound = Math.floor(minutes);
                var seconds = shijiancha / 1000 - (24 * 60 * 60 * daysRound) - (60 * 60 * hoursRound) - (60 * minutesRound);
                return (parseInt(days) ? parseInt(days) + '天' : '') + (parseInt(hours) ? parseInt(hours) + '小时' : '') + (parseInt(minutes) ? parseInt(minutes) + '分' : '') + (parseInt(seconds) ? parseInt(seconds) + '秒' : '')
            }
        };
        var msg = '&nbsp;';
        if (activityIsStart == 0 || activityIsStart == 1) {
            var time = convertTime(time);
            if (time) {
                msg = '距离活动' + ( activityIsStart ? '结束' : '开始') + '还有<span class="tc-m" style="padding-left:1em;">' + time + '</span>';
            }
            $('#interval').html(msg);

        } else if (activityIsStart == 2) {
            $('#interval').html(activityMsg);
        }

        $('#interval-split').addClass('bc-split');
    }
    show(activityTime);

    if (activityTime && activityTime > 0) {
        activityInterval = setInterval(function() {
            activityTime = activityTime - 1000;
            if (activityTime < 1000) {
                clearInterval(activityInterval);
            }
            show(activityTime);
        }, 1000);
    }
}

appcan.ready(function() {
    //关闭商品搜索页面
    appcan.window.evaluateScript({
        name : 'ProdSearch_EC',
        scriptContent : 'appcan.window.close(-1);'
    });
    getUrlParam(initPage);

    //关闭商品搜索页面
    appcan.window.evaluateScript({
        name : 'prodSearch',
        scriptContent : 'appcan.window.close(-1);'
    });

    uexWindow.onKeyPressed = function(keyCode) {
        if (keyCode == 0) {
            goback();
        }
    }
});

var goback = function() {
    LocStorage.remove('ProdSearchCondition');
    LocStorage.remove('ProdListParam');
}

appcan.button("#goback", "btn-act", function() {
    goback();
    appcan.window.close(-1);
});

/**
 *页面第一次加载时需处理页面全局参数和控件
 */
var firstLoad = function() {
    var method = pageParam.method;
    var selfParam = param[method];
    $('#title').html(pageParam.title || selfParam.name || '商品列表');

    //根据参数向页面添加控件
    var extraInfo = param[pageParam.method] && param[pageParam.method].extraInfo ? param[pageParam.method].extraInfo : {};

    //弹出式商品搜索
    extraInfo.popProdSearch && addSearchBtn();
    //编辑
    extraInfo.edit && addEditBtn();
    //商品搜索
    extraInfo.ProdSearch && addProdSearch();
    //存显示商品搜索
    extraInfo.ShowProdSearch && addShowProdSearch();
    //总代理分类  选项卡
    extraInfo.AgentProd && addAgentClassifyTab();
    //中药分类  选项卡
    extraInfo.ZYProd && addZYClassifyTab();
    //商品类别 选项卡
    extraInfo.Category && addCategoryTabs(extraInfo.noAllCategory);
    //排序选项卡
    !extraInfo.noSort && addSortTabs(extraInfo.nomanufactsort, extraInfo.showmodel);
    //活动计时器
    extraInfo.interval && addInterval();
    //采购推荐
    extraInfo.RecommendPur && addRecommendTab();
    //扫描客户信息的二维码
    extraInfo.QRCodeScanner && addQRCodeScanner();

    /*if (!isPhone) {
     $('#btn_search').addClass('nav-btn').append($('<div class="fa fa-plus" style="font-size: 1.25em;"></div>'));

     appcan.button("#btn_search", "btn-act", function() {
     appcan.frame.evaluateScript({
     name : '',
     popName : 'content',
     scriptContent : 'if (isLoading) {return;}page++;initPage();'
     });
     });
     }*/
}
/**
 *根据页面参数 加载页面
 */
var pageParam;
var initPage = function(urlParam, urlParamObj) {
    if (!urlParamObj.method) {
        if (LocStorage.get('ProdListParam')) {
            var extraInfo = JSON.parse(LocStorage.get('ProdListParam'));
            for (var i in extraInfo) {
                urlParam += ( urlParam ? '&' : '') + i + '=' + extraInfo[i];
            }
            urlParamObj = $.extend({}, urlParamObj, extraInfo);
        }
        urlParamObj.method = 'B2B_SALE';
        urlParam += ( urlParam ? '&' : '') + 'method=' + 'B2B_SALE';
    }
    pageParam = urlParamObj;

    urlParam && urlParamObj && firstLoad();

    if (pageParam.barCode) {
        appcan.window.evaluateScript({
            name : 'B2BApp',
            scriptContent : 'loading.hide();'
        });
    }

    if (param[pageParam.method] && param[pageParam.method].extraInfo && param[pageParam.method].extraInfo.Category && param[pageParam.method].extraInfo.noAllCategory) {
        urlParam += '&category=西药';
    }
    var user = JSON.parse(LocStorage.get('UserAgent'));
    switch(pageParam.method) {
    case 'B2B_SALE_ZY':
        urlParam += '&category=20';
        break;
    case 'B2B_SALE_QX':
        if (urlParam.indexOf('category') == -1) {
            urlParam += '&category=10';
        }
        break;
    case 'B2B_SALE_YDCB':
        urlParam += '&columnId=' + user.ydcb_id;
        break;
    case 'B2B_SALE_XPZS':
        urlParam += '&columnId=' + user.xpzs_id;
        break;
    }

    var method = pageParam.method,
        titHeight = $('#content').offset().top + 1,
        showmodel = $('#showmodel:checked').length;

    var extraInfo = param[pageParam.method] && param[pageParam.method].extraInfo ? param[pageParam.method].extraInfo : {};
    if ( typeof (extraInfo.showmodel)) {
        showmodel = extraInfo.showmodel;
    }
    appcan.frame.open("content", "ProdList_content.html?" + urlParam + '&showmodel=' + showmodel, 0, titHeight);
    window.onorientationchange = window.onresize = function() {
        appcan.frame.resize("content", 0, titHeight);
    }
    if (urlParamObj.keyWord) {
        $('#prod').val(urlParamObj.keyWord);
    }
}