var fontSize;
appcan.ready(function() {
    fontSize = parseInt(document.defaultView.getComputedStyle(document.getElementsByTagName('body')[0], null).fontSize);
    createPhoto();
    
    uexActionSheet.onClickItem = clickActionSheet;
    uexImage.onPickerClosed = imagePickerClosed;
    uexCamera.cbOpen = cameraClosed;
});

function createPhoto(){
    var parent = $('#photos');
    if (parent.length == 1) {
        for (var i = 0,
            len = 5; i < len; i++) {
            var photo = $('<img class="photo photo_none"/>');
            if (i == 0) {
                photo.removeClass('photo_none').addClass('photo_add');
            }
            parent.append(photo);
        }
    }
    
    $('#photos .photo').bind('tap', clickPhoto);
    $('#photos .photo').bind('longTap', longTapPhoto);
}

function resetPhoto() {
    /*$('#photos .photo[src]').removeAttr('src').addClass('photo_none');
    $('#photos .photo_add').removeClass('photo_add').addClass('photo_none');
    $('#photos .photo').first().removeClass('photo_none').addClass('photo_add'); */
   $('#photos').empty();
   createPhoto();     
}

function createActionSheet() {
    var x = 0;
    var y = 0;
    var width = 0;
    //如果传0，默认是屏幕宽度
    var height = 0;
    var JsonData = '{"actionSheet_style":{"frameBgColor":"#ffffff","frameBroundColor":"#00000000","frameBgImg":"","btnSelectBgImg":"res://btn-act.png","btnUnSelectBgImg":"res://btn.png","cancelBtnSelectBgImg":"res://cancel-act.png","cancelBtnUnSelectBgImg":"res://cancel.png","textSize":"17","textNColor":"#ffffff","textHColor":"#ffffff", "cancelTextNColor":"#000000","cancelTextHColor":"#000000", "actionSheetList":[{"name":"相册"},{"name":"拍照"}]}}';
    uexActionSheet.open(x, y, width, height, JsonData);
}

var clickActionSheet = function(index) {
    var max = 5 - $('#photos .photo[src]').length;
    if (index == 0) {
        var param = {
            max : max,
            detailedInfo : true
        };
        param = JSON.stringify(param);
        uexImage.openPicker(param);
    } else if (index == 1) {
        uexCamera.open();
    }
};

var clickPhoto = function() {
    var con = $(this);
    if (!con.hasClass('photo_none')) {
        //添加图片
        if (con.hasClass('photo_add')) {
            createActionSheet();
            if (!isPhone) {
                showPhoto('img/IMG_0076.JPG');
            }
        } else {
            createActionSheet();
        }
    }
};

var longTapPhoto = function() {
    var con = $(this);
    alert('确定删除？', {
        btsArray : ['确定', '取消'],
        callback : function(opId, dataType, data) {
            if (data == 0) {
                if (!con.hasClass('photo_none') && !con.hasClass('photo_add')) {

                    var parent = con.parent();
                    con.removeAttr('src');
                    con.remove();
                    if (parent.find('.photo_add').length == 0) {
                        con.addClass('photo_add');
                    } else {
                        con.addClass('photo_none');
                    }
                    parent.append(con);
                }
            }
        }
    });
};

//本机选取照片的回调
var imagePickerClosed = function(param) {
    param = JSON.parse(param);
    if (!param.isCancelled) {
        $.each(param.data, function(index, path) {
            showPhoto(path);
        });
    }
};
//拍照结束
var cameraClosed = function(opId, dataType, data) {
    showPhoto(data);
};

//显示图片信息
var showPhoto = function(path) {

    var platform = parseInt(LocStorage.get('platform'));
    var add = $('.photo_add'),
        next = add.next();
    add.removeClass('photo_add');
    add[0].src = path;
    if (next.length > 0) {
        next.removeClass('photo_none').addClass('photo_add');
    }
};
