var locationCallbackFn,
    getLocatoinCount = 0,
    isBaidumapLocation = false;
var startLocatoin = function(callbackfn, runingbackground, local) {

    uexBaiduMap.onSDKReceiverError = function(data) {
        log('初始化地图时，key非法、网络错误:' + data);
    };

    locationCallbackFn = callbackfn;
    if (isPhone) {
        if (local && local.latitude && local.longitude) {
            openMap(local.longitude, local.latitude, local.selectorId);
        } else {
            getLocatoinCount = 0;

            //默认返回多次
            uexLocation.onChange = function(latitude, longitude) {
                if (getLocatoinCount == 0) {
                    getLocatoinCount++;
                    openMap(longitude, latitude, local.selectorId);
                }
                //获取定位之后关闭
                uexLocation.closeLocation();
            };
            if (!runingbackground) {
                loading.show('初始化…');
            }
            uexLocation.openLocation();
            setTimeout(function() {
                if (getLocatoinCount == 0) {
                    loading.hide();
                    alert('未获取到位置权限，请先检查应用位置权限或网络。');
                }
            }, 5000);
        }

    } else {
        //电脑模式
        getlocation({
            latitude : 30.546612,
            longitude : 114.197362
        });
    }
}
function getlocation(local) {
    loading.hide();

    if (local.longitude == 0 || local.latitude == 0) {
        alert('应用未获取到位置权限，请先设置应用权限。');
        return;
    }
    if ( typeof locationCallbackFn == 'function') {
        locationCallbackFn(local.latitude, local.longitude);
    }
}

var baiduNoCallback = false;
/**
 * 通过经纬度 设置地图
 */
function openMap(longitude, latitude, selectorId) {
    baiduNoCallback = false;

    var mapPosition = {
        top : 0,
        left : 0,
        width : 0,
        height : 0
    };
    if (selectorId) {
        mapPosition = $('#' + selectorId).offset();
    }

    uexBaiduMap.cbOpen = function() {
        //获取到当前位置的回调
        uexBaiduMap.cbCurrentLocation = function(data) {
            if (baiduNoCallback) {
                baiduNoCallback = false;
                var obj = eval('(' + data + ')');
                getlocation(obj);
                if (!selectorId) {
                    uexBaiduMap.close();
                } else {
                    uexBaiduMap.setCenter(obj.longitude, obj.latitude);

                    //显示用户位置
                    //uexBaiduMap.setMyLocationEnable(1);

                    var param = [{
                        id : 'center',
                        longitude : obj.longitude,
                        latitude : obj.latitude,
                        icon : "res://position_me.png"
                    }];
                    param = JSON.stringify(param);
                    uexBaiduMap.addMarkersOverlay(param);

                    uexBaiduMap.setZoomLevel(17);
                }

            }
        };
        uexBaiduMap.getCurrentLocation();
        //点击地图的监听
        uexBaiduMap.onMapClickListener = MapClick;
    };
    uexBaiduMap.open(mapPosition.left, mapPosition.top, mapPosition.width, mapPosition.height, longitude, latitude);
    baiduNoCallback = true;
    if (!selectorId) {

        setTimeout(function() {
            if (baiduNoCallback) {
                baiduNoCallback = false;
                getlocation({
                    longitude : longitude,
                    latitude : latitude
                });
            }
        }, 5000);
    }
}

/*
 * 添加标注
 */
var addMarker = function(MarkersInfo) {
    if ($.isArray(MarkersInfo)) {
        var param = [];
        $.each(MarkersInfo, function(index, item) {
            if (item.longitude && item.latitude) {
                var temp = {
                    id : item.id,
                    longitude : item.longitude,
                    latitude : item.latitude,
                    icon : "res://position_all.png"
                };

                if (item.bubble) {
                    temp.bubble = item.bubble;
                }
                param.push(temp);
            }

        });

        param = JSON.stringify(param);
        uexBaiduMap.addMarkersOverlay(param);
    }
}
