var rootpage = true,
    appIdentify = {};

appcan.ready(function() {
    LocStorage.remove('globalhost');
    uexWidget.onResume = function() {
        log("Login页面程序恢复");
        if (i != -1 && i != 0) {
            CheckService(true);
        }
    }
    var getVerInfoCount = 0;
    var getVersionInfo = function() {
        $.ajax({
            timeout : 3000,
            url : global.updateconfig + 'data.json',
            dataType : 'json',
            success : function(data) {
                log('success:' + global.updateconfig + 'data.json');
                appIdentify = data;
                appVersionCheck();
                loading.hide();
            },
            error : function(XMLHttpRequest, textStatus, errorThrown) {
                //ajaxError(XMLHttpRequest, textStatus, errorThrown);
                if (getVerInfoCount < 2) {
                    getVerInfoCount++;
                    getVersionInfo();
                } else {
                    loading.hide();
                    appVersionCheck();
                }
            },
            beforeSend : function() {
                log(global.updateconfig + 'data.json');
                loading.show('数据加载中…');
            },
            complete : function(xhr, status) {

            }
        });
    }
    if (isPhone) {
        getVersionInfo();
    } else {
        appVersionCheck();
    }

});

var checkSlide = function() {

    if (appIdentify && appIdentify[widgetInfo.version] && appIdentify[widgetInfo.version]['img'] && !(LocStorage.get('showSlide') && appIdentify[widgetInfo.version]['img'] == LocStorage.get('showSlide'))) {
        LocStorage.set('prevSlide', appIdentify[widgetInfo.version]['img']);

        appcan.window.open({
            name : 'lay',
            data : 'lay.html',
            dataType : 0,
        });
    } else {
        getDateToInitPage();
    }
}
var renderPage = function() {
    appcan.button("#btn_Login", "btn-act", RequestLogin);
    appcan.button("#btn_Register", "btn-act", function() {
        open({
            name : 'Register',
            data : 'Register.html'
        });
    });
    appcan.button("#btn_ForgetPwd", "btn-act", function() {
        open({
            name : 'FindPassword',
            data : 'FindPassword.html'
        });
    });
    if (!isPhone && global.host != 'http://b2b.yyjzt.com/') {
        //湖北
        LocStorage.set('login', '{"name" : "hbjzt","password" : "654321","branchId" : "J55"}');        
    }
    

    uexWindow.onKeyPressed = function(keyCode) {
        if (keyCode == 0) {
            alert('您确定要退出九州通医药批发吗?', {
                callback : function(opId, dataType, data) {
                    if (data == 0) {
                        LocStorage.clean();
                        uexWidgetOne.exit(0);
                    }
                },
                btsArray : ['确定', '取消']
            });
        }
    };
    //设置当前页面拦截返回按键
    uexWindow.setReportKey(0, 1);
}
var getDateToInitPage = function() {
    $('[name="page"]').removeClass('uhide');
    renderPage();
    /*var branch = LocStorage.get('branchData');
     if (branch) {
     InitPage(JSON.parse(branch));
     } else {
     AjaxFn(urls.BRUNCH_LIST, null, function(data) {
     InitPage(data);
     LocStorage.set('branchData', JSON.stringify(data));
     });
     }*/
    AjaxFn(urls.BRUNCH_LIST, null, function(data) {
        InitPage(data);
    });
}
var InitPage = function(data) {
    Init.select($('[name="branchId"]'), data, 'id', 'text');
    appcan.select(".select", function(ele, value) {
        var data = $(ele[0].selectedOptions[0]).attr('data');
        data = JSON.parse(data);
        if(data.requestUrl){
            LocStorage.set('globalhost', data.requestUrl);
        }
        else{
            LocStorage.remove('globalhost');
        }
        setGlobalInfo();
    });
    loadUserInfo();
}
var loadUserInfo = function() {
    var login = LocStorage.get('login');
    if (login) {
        $('#remember')[0].checked = true;
        login = JSON.parse(login);
    } else {
        $('#remember')[0].checked = false;
        login = {};
    }
    form.set($('.info'), login);
}
//登录请求
var loginData;
var RequestLogin = function(e, isAuto) {
    var data = form.get($('.info'));
    if (!data.name) {
        alert('用户名不能为空!');
        return;
    }
    if (!data.password) {
        alert('密码不能为空!');
        return;
    }
    if (!data.branchId) {
        alert('公司不能为空!');
        return;
    }

    var widgetInfo = JSON.parse(LocStorage.get('widgetInfo')),
        deviceInfo = JSON.parse(LocStorage.get('deviceInfo'));
    data.version = widgetInfo.version;
    data.imei = deviceInfo.imei;
    loginData = data;
    AjaxFn(urls.LOGIN, data, function(login) {
        if (!isAuto) {
            var loclogin = JSON.parse(LocStorage.get('login') || '{}');
            if (loclogin.name != loginData.name && loclogin.name) {
                //清除商品列表搜索历史
                LocStorage.remove('arr');

                LocStorage.remove('noPic');
                LocStorage.remove('JPushTags');
                LocStorage.remove('LastMsgConfigInfo');
                LocStorage.remove('ShowFairsWindow');

                JPushFile.clean();
            }

            if ($('#remember:checked').length == 1) {
                LocStorage.set('login', JSON.stringify(loginData));
            }

            LocStorage.set('UserAgent', JSON.stringify(login));

            //isSalesMan  1:业务员;0 :其他普通用户
            if (login.isSalesMan == '1') {
                LocStorage.clean(['UserAgent', 'arr']);

                open({
                    name : 'OutsideBusinessApp',
                    data : 'OutsideBusinessApp/index.html'
                });
            } else {
                open({
                    name : 'B2BApp',
                    data : 'b2bApp/index.html'
                });
            }
            /*open({
             name : 'Flower',
             data : 'b2bApp/Flower.html'
             });*/

            if ( typeof JPushSetTags == 'function') {
                JPushSetTags();
            }

        }
    }, {
        loadView : true
    });
}