var platform,
    widgetInfo;

/*
 * 监测应用版本
 */
function appVersionCheck() {
    platform = uexWidgetOne.getPlatform();
    if (!isPhone) {
        platform = 0;
    }
    LocStorage.set('platform', platform);

    //获取应用相关信息回调
    uexWidgetOne.cbGetCurrentWidgetInfo = function(opId, dataType, data) {
        if (dataType == 1) {
            log('当前应用信息:' + data);
            LocStorage.set('widgetInfo', data);
            widgetInfo = JSON.parse(data);
            CheckService();

            var deviceInfo = {};
            uexDevice.cbGetInfo = function(opCode, dataType, data) {

                var device = JSON.parse(data);
                for (var p in device) {
                    deviceInfo[p] = device[p];
                }
                LocStorage.set('deviceInfo', JSON.stringify(deviceInfo));
            }
            var arr = {
                '系统版本' : "1",
                '厂商信息' : "2",
                'IMEI信息' : "10",
                '运营商名称' : "15",
                '型号' : "17",
                '分辨率' : "18"
            };
            for (var i in arr) {
                uexDevice.getInfo(arr[i]);
            }

            if (!isPhone) {
                LocStorage.set('deviceInfo', JSON.stringify({
                    imei : 'PC Simulator'
                }));
            }

        }
    };
    uexWidgetOne.getCurrentWidgetInfo();
    //获取应用相关信息
}

var i = 0,
    appId;
/**
 * 检查服务器上版本
 */
var CheckService = function(runinBackground) {
    i++;
    var login = LocStorage.get('UserAgent');
    appId = widgetInfo.appId;
    if (login) {
        login = JSON.parse(login);
        if (login.isSalesMan) {
            appId = 'aaaau10011';
            //上游厂家 供应商服务
        } else {
            appId = 'aaaau10004';
            //下游客户  九州通医药
        }
    }

    AjaxFn(urls.UPDATE_APP, {
        appType : platform == 0 ? 'IOS' : 'ANDROID',
        appId : appId
    }, getCheckVersion, {
        errorFn : function() {
            if (i == 3) {
                toast.show('版本检测失败!请检查网络或联系管理员!');
            }
        },
        completeFn : function() {
            if (i != -1) {
                if (i < 3) {
                    CheckService();
                } else {
                    setTimeout(function() {
                        CheckService(true);
                    }, 3000);
                }
            }
        },
        runinBackground : runinBackground
    });
}
/**
 * @param {Object} result
 */
var getCheckVersion = function(result) {
    if (i >= 3) {
        toast.hide();
    }
    
    i = -1;
    if (!result.appSeparate) {
        appId = widgetInfo.appId;
    }
    if (isPhone&&result.versionInfo && result.versionInfo != widgetInfo.version && result.versionInfo > widgetInfo.version) {
        var msg = result.versionInfo + '版本已发布!\n当前版本:' + widgetInfo.version + '.';
        if (appIdentify[result.versionInfo] && appIdentify[result.versionInfo]['note']) {
            msg += '\n升级说明:\n' + appIdentify[result.versionInfo]['note'];
        }
        alert(msg, {
            title : '软件版本更新',
            callback : function(opId, dataType, data) {
                if (data == 0) {
                    if (platform == 0) {
                        UpdateAPP.IOS();
                    } else if (platform == 1) {
                        UpdateAPP.Andriod();
                    }
                } else {
                    checkSlide();
                }
            },
            btsArray : ['立即更新', '下次再说']
        });
    } else {
        checkSlide();
    }
};

var UpdateAPP = {
    IOS : function() {
        var loadUrl = 'itms-services://?action=download-manifest&url=' + global.apploadpath + widgetInfo.appId + '.plist';
        uexWidget.loadApp(loadUrl);
        uexWidgetOne.exit(0);
    },
    Andriod : function() {
        //创建一个下载对象,回调
        uexDownloaderMgr.cbCreateDownloader = function(opCode, dataType, data) {
            if (data == 0) {
                var loadUrl = global.apploadpath + widgetInfo.appId + '.apk',
                    savePath = 'wgt://data/DownLoad/' + widgetInfo.appId + '.apk';

                //下载状态改变，回调
                uexDownloaderMgr.onStatus = function(opCode, fileSize, percent, status) {
                    switch (status) {
                    case 0:
                        var size = Number.FloatDivision(Number.FloatDivision(fileSize, 1024), 1024).toFixed(2);
                        uexWindow.toast('0', '5', '文件大小：' + size + 'M,已下载' + percent + '%.', 0);
                        break;
                    case 1:
                        uexWindow.closeToast();
                        if (platform == 1) {
                            uexWidget.installApp(savePath);
                        }
                        uexDownloaderMgr.closeDownloader(opCode);
                        break;
                    case 2:
                        uexWindow.closeToast();
                        uexDownloaderMgr.closeDownloader(opCode);
                        alert('下载失败！');
                        break;

                    }
                };

                uexWindow.toast('0', '5', '准备下载…', 0);
                uexDownloaderMgr.download(1, loadUrl, savePath, '0');
            } else {
                alert('下载对象创建失败！');
            }
        };
        uexDownloaderMgr.createDownloader(1);
    }
};
