/**
 *布局模板
 */
var temp = {
    subject : '<div class="tab ub-f1"><div class="ulev-1 ub "><div class="ub-f1 ub ub-ver item ub-ac sc-text-tab"><div class="ub-f1 <%-icon%> tx-c"></div><div class="ulev tx-c"><%-label%></div></div></div></div>',
    prod : '<div name="prod" class="ub ub-ac"><%if(typeof(isEnd)!="undefined"&&isEnd=="1"){%><div class="list-sale-end"></div><%}%><%if(typeof pageEditing!="undefined"&&pageEditing){%><label style="display:block;" type="selfinput"><div class="checkbox"><input type="checkbox" class=""></div></label><%}%><div class="ub-f1 ub ub-at"><div class="img" <%if(typeof pageEditing!="undefined"&&pageEditing){style="marginLeft:0;"}%>><img src="<%-src%>" onerror="imgerror(this)"><div class="flag_price ut-s">零售价:<%-retailPrice%></div></div><div class="ub-f1 uinn ubb bc-border" name="detail"><div class="prodinfo"><span class="uf-w2"><%-merchandiseName%>&nbsp;/&nbsp;<%-merchandiseSpec%>&nbsp;/&nbsp;<%-manufacturer%></span> 中/大包装(单位):<%-middlingPacking%>/<%-packingNumber%>(<%-merchandiseUnit%>) |  <%if(!retail){%>不<%}%>可拆零 </div><div class="ub ub-ac"><div class="price umw4">价格:<%if(!memberPrice||memberPrice=="0"){%>--<%}else{%><%-memberPrice%><%}%></div><div class="store ub-f1 tx-c uinn-r1">库存:<%-storageNumber%></div><%if(typeof mechandisePrice !="undefined"){%><div class="ub-f1">购进价:<%-mechandisePrice%></div><%}%></div><%if(typeof fairsPolicy !="undefined"){%><div class="policy ulev-1 ut-s"><%-fairsPolicy%></div><%}%></div></div></div>',
    logo : '<div class="tab ub-f1"><img class="logo" src="<%-src%>" onerror="imgerror(this)"></div>'
};

/**
 *广告位信息加载
 */
var loadBanner = function(banners, sliderId, orgurl) {
    var slider = appcan.slider({
        //var slider = Slider({
        selector : '#' + sliderId,
        aspectRatio : 6 / 16,
        hasLabel : false,
        hasContent : false,
        hasCircle : true,
        auto : (banners.length > 1 ? 2000 : 0),
        index : 0,
        flippingEnbaled : 1,
        bounceState : '0'
    }),
        data = [];

    if (banners.length > 0) {
        $.each(banners, function(index, banner) {
            if (orgurl && !banner[orgurl]) {
                return;
            }
            if (banner.LINK) {
                var val = banner.LINK.split('?'),
                    params = splitUrlParam(val[1]);
                data.push({
                    img : banner.URL,
                    name : banner.name || banner.URL,
                    link : banner.LINK,
                    data : params
                });
            } else {
                data.push({
                    img : banner.URL
                });
            }

            /*if (isPhone && LocStorage.get('platform') == 1) {
             $('body').append('<img src=' + banner.URL + ' class="uhide"/>');
             }*/
        });
        slider.set(data);
        $('#' + sliderId + ' .label1').css('background-color', 'rgba(152, 139, 123, 0)');
        $('#' + sliderId + ' .label').remove();

        slider.on("clickItem", function(index, data) {
            if (data.link) {
                open({
                    name : data.name,
                    data : data.link
                });
            }
        });
    }
}
/**
 *加载分类模块入口
 */
var loadSubject = function(subjects, parentId, tabclick, template) {
    !template && ( template = temp.subject);
    var render = appcan.view.template(template),
        tabs = $('#' + parentId),
        tab,
        cellcount = 4,
        parent;

    if (!tabs.hasClass('tabs')) {
        tabs.addClass('tabs');
    }

    $.each(subjects, function(index, item) {
        if (index % cellcount == 0) {
            parent = $('<div class="ub ub-ac"></div>');
            tabs.append(parent);
        }
        tab = $(render(item));
        tab.bind(touch, item, tabclick);
        parent.append(tab);
    });
    if (parent) {
        var childrenCount = parent.children().length;
        if (childrenCount < cellcount) {
            for (var i = 0,
                len = cellcount - childrenCount; i < len; i++) {
                parent.append('<div class="tab ub-f1"></div>');
            }
        }

        $('.tabs .tab_m').css('height', 'inherit');
    }
}
var isLoading = false;
/**
 *分页请求加载
 * path      服务路径
 * data      服务参数
 * listStr   结果中数据属性字符串格式
 * canGoNextStr      结果中分页是否有下一页字符串格式
 */
function listPage(path, data, searchFn, loadFn, listStr, canGoNextStr) {
    !listStr && ( listStr = 'list');
    !canGoNextStr && ( canGoNextStr = 'isCanGoNext');
    $('#NoDataTip').addClass('uhide');
    var runinBackground = (data.page != 1);
    isLoading = true;
    AjaxFn(path, data, function(result) {
        //log('查询参数:' + JSON.stringify(data));
        var list = result[listStr] || [],
            canGoNext = result[canGoNextStr];
        //log('下页标识:' + canGoNext);
        if (!canGoNext) {
            bounce.remove();
        }

        loadFn(list, result);
        bounce.reset(1);

        //加载初始化必须写在bounce.reset之后，否则IOS系统下第一次加载没有提示信息
        if (data.page == 1 && canGoNext) {
            bounce.init(1, function() {
                if (isLoading) {
                    //log('加载中咧');
                    return;
                }
                page++;
                searchFn();
            });
        }

        //无数据需要处理暂无数据提示
        if (!(list && list.length > 0)) {
            if (data.page == 1) {
                if ($('#NoDataTip').length > 0) {
                    $('#NoDataTip').removeClass('uhide');
                } else {
                    $('body').append('<div id="NoDataTip">暂无数据</div>');
                }
            }
        }
        isLoading = false;
    }, {
        runinBackground : runinBackground
    });
}

/**
 *加入收藏
 * @param {Object} prod
 */
var addCollect = function(prod) {
      var user = JSON.parse(LocStorage.get('UserAgent'));
      var data = {
        userSupplierId:user.userSupplierId,
        merchandiseId : prod.merchandiseId
    };
    AjaxFn(urls.ADD_TO_COLLECT, data, function(result) {
        if (result.success) {
           uexWindow.evaluateMultiPopoverScript('OutsideBusinessApp', 'content', 'content_2', 'initPage();');
        }
        toast.show(result.msg, 2000);
    });
}
/**
 *取消收藏
 * @param {Object} prod
 */
var removeCollect = function(prod) {
    var data = {
        attentionId : prod.attentionId
    };
    AjaxFn(urls.REMOVE_FROM_COLLECT, data, function(result) {
        if (result.success) {
            page = 1;
            initPage();
        }
        toast.show(result.message, 2000);
    });
}
/*大量数据分页*/
var pagelist = function(list, pageIndex, pageSize, callbackFn) {
    pageIndex = parseInt(pageIndex) || 1,
    pageSize = parseInt(pageSize) || 10;

    var start = (pageIndex - 1) * pageSize,
        end = pageIndex * pageSize;

    var subList = [];
    if (list.length < start) {
        //log('没有值');

        if ( typeof callbackFn == 'function') {
            callbackFn(subList, pageIndex, false, list);
        }
    }

    if (end > list.length) {
        end = list.length;
    }

    for (var i = start; i < end; i++) {
        subList.push(list[i]);
    }

    if ( typeof callbackFn == 'function') {
        callbackFn(subList, pageIndex, list.length > end, list);
    }
}

appcan.ready(function() {
});

