var page = 1,
    pageSize = 10,
    search,
    prodShowData = [],
    prodData = [],
    imagePath,
    lv,
    ol,
    showModel,
    optionBtns = ["加入收藏", "加入购物车"],
    optionBtnsHtml = '<div name="extra"><div name="collect"></div><div name="shopping"></div></div>',
    canAddShopping = true,
    isCart = true,
    user;

appcan.ready(function() {
    user = JSON.parse(LocStorage.get('UserAgent'));
    //图表
    lv = appcan.listview({
        selector : "#viewlv",
        type : "thinLine",
        hasIcon : false,
        hasAngle : false,
        hasTouchEffect : false,
        hasSubTitle : false,
        multiLine : 6
    });
    lv.on("click", function(ele, obj, curEle) {
        var name = curEle.attr('name'),
            data = obj.data;
        if (name == 'remove') {
            removeCollect(data);
        } else if (name == 'collect') {
            addCollect(data);
        } else if (name == 'shopping') {
            addShoppingCart(data);
        } else {
            open({
                name : 'ProdDetails_EC',
                data : 'ProdDetails_EC.html?merchandiseId=' + obj.data.merchandiseId + (pageParam.method == 'B2B_INSTITUTION' ? '&from=isInstitution' : '')
            });
        }
    });

    //列表
    ol = appcan.optionList({
        selector : "#viewol",
        type : "hiddenLine",
        duration : "300ms",
        multiShow : false
    });
    ol.on("click", function(ele, obj, curEle) {
        if (obj.data.isEnd == '1') {
            return;
        }
        if (curEle.hasClass('policy')) {
            $(curEle).toggleClass('ut-s');
        } else {
            open({
                name : 'ProdDetails_EC',
                data : 'ProdDetails_EC.html?merchandiseId=' + obj.data.merchandiseId + (pageParam.method == 'B2B_INSTITUTION' ? '&from=isInstitution' : '')
            });
        }
    });
    getUrlParam(initPage);
});

/**
 *更换页面显示模式 0：列表 ；1：单元格
 */
var switchShowModel = function(type) {
    showModel = type;
    prodShowData = [];
    var data = Clone(prodData);
    //复制数据
    prodData = [];
    if (showModel == 1) {
        if (ol) {
            ol.set([]);
            $(window).scrollTop(0);
        }
        loadCell(data, imagePath);
    } else {
        $('#viewlv').addClass('uhide');

        if (lv) {
            lv.set([]);
            $(window).scrollTop(0);
        }
        loadList(data, {
            isCart : isCart
        });
    }
}
//界面内排序
var switchSort = function(sortFiled, sort) {
    var sortData = [];

    $.each($('li[data-index]'), function(index, li) {
        var val = parseFloat(li.lv_data.data[sortFiled]);
        var compareVal,
            position = -1;
        $.each(sortData, function(i, item) {
            var temp = parseFloat(item.lv_data.data[sortFiled]);
            //降序
            if (sort == 1) {
                if (temp < val) {
                    position = i;
                    return false;
                }
            } else {
                if (temp > val) {
                    position = i;
                    return false;
                }
            }
        });

        if (position == -1) {
            position = (sort == 1 ? sortData.length : 0);
        }
        sortData.splice(position, 0, li);
        position = -1
    });

    if (showModel == 1) {
        $('li.lis').parent().remove();
        cellPlay(sortData);
    } else {
        var con = $('#viewol');
        $.each(sortData, function(index, li) {
            con.append(li);
        });
    }
}
var pageEditing = false;
/**
 *控制页面编辑
 */
var EditPage = function(editModel) {
    //编辑状态
    if (editModel == 1) {
        pageEditing = true;
        var checkbox = '<label style="display:block;" type="selfinput"><div class="checkbox uhide"><input type="checkbox" class=""></div></label>';
        $.each($('[name="prod"]'), function(index, item) {
            $(item).prepend($(checkbox));
            $(item).find('.img').css('marginLeft', '0');
        });

        $('.checkbox').removeClass('uhide');

    } else {
        pageEditing = false;
        $('.checkbox').parent().remove();
        $('.img').css('marginLeft', '1em');
    }
}
/*删除已选数据*/
var deleteChoice = function() {
    if (pageParam.method == 'B2B_COLLECT') {
        var check = $('input[type="checkbox"]:checked');
        var count = check.length,
            completeCount = 0,
            successCount = 0;
        if (check.length == 0) {
            loading.hide();
            alert('请选定数据再操作!');
        } else {
            alert('确定取消收藏' + check.length + '项已选信息?', {
                btsArray : ['确定', '取消'],
                callback : function(opId, dataType, data) {
                    if (data == 0) {
                        $.each(check, function(index, item) {
                            var li = $(item).parents('li'),
                                lv_data = li[0].lv_data,
                                data = lv_data.data;

                            var param = {
                                attentionId : data.attentionId
                            };
                            AjaxFn(urls.REMOVE_FROM_COLLECT, param, function(result) {
                                if (result.success) {
                                    successCount++;
                                }
                                //toast.show(result.message, 2000);
                            }, {
                                completeFn : function() {
                                    completeCount++;
                                    if (completeCount == count) {
                                        page = 1;
                                        initPage();

                                        var msg = '共' + successCount + '项,取消收藏成功!';
                                        if (successCount != count) {
                                            msg += '\r共' + (count - successCount) + '项,取消收藏失败!';
                                        }

                                        toast.show(msg, 2000);

                                        appcan.window.evaluateScript({
                                            name : 'ProdList',
                                            scriptContent : '$("#changeAll")[0].checked=false;$("#choicetext").html("全选");'
                                        });
                                    }
                                }
                            });
                        });
                    } else {
                        loading.hide();
                    }
                }
            });
        }

    }
}
/**
 *页面初始化
 */
var init = function(data, result) {
    imagePath = global.host + result.merchandiseImagePath;
    if (result.merchandiseImagePath.indexOf('http://') == 0) {
        imagePath = result.merchandiseImagePath;
    } else {
        imagePath = global.imghost + result.merchandiseImagePath;
    }

    if (page == 1) {
        prodShowData = [];
        prodData = [];
        isCart = result.isCart;
        if (result.isCart == '0') {
            ol = appcan.listview({
                selector : "#viewol",
                type : "thickLine",
                hasAngle : false,
            });
            //列表
            ol.on("click", function(ele, obj, curEle) {
                if (curEle.hasClass('policy')) {
                    $(curEle).toggleClass('ut-s');
                } else {
                    open({
                        name : 'ProdDetails_EC',
                        data : 'ProdDetails_EC.html?merchandiseId=' + obj.data.merchandiseId + (pageParam.method == 'B2B_INSTITUTION' ? '&from=isInstitution' : '')
                    });
                }
            });
        }
    }

    if (showModel == 1) {
        loadCell(data, result);
    } else {
        loadList(data, result);
    }
}
var pageParam,
    page = 1;
var initPage = function(urlParam, urlParamObj) {
    if (urlParamObj) {
        pageParam = urlParamObj;
        if ( typeof (showModel) == 'undefined') {
            showModel = pageParam.showmodel;
        }
    }
    if (urls[pageParam.method]) {
        var param = Clone(pageParam);
        delete param.method;
        delete param.title;
        delete param.showmodel;

        param.pageSize = pageSize;
        param.page = page;
        listPage(urls[pageParam.method], param, initPage, init);
    }

}
var resetPage = function(insertParam) {
    var reSearch = false;
    for (var param in insertParam) {
        if (insertParam[param] != pageParam[param]) {
            reSearch = true;
            break;
        }
    }
    if (reSearch) {
        var param = Clone(pageParam);
        page = 1;
        param = $.extend({}, param, insertParam);
        initPage(null, $.extend({}, param, insertParam));
    } else {
        toast.show('商品查询条件无变化，本次请求无效！', 1500);
    }

}
/**
 *商品列表加载
 */
var loadList = function(data, result) {

    if (result && pageParam.method == 'B2B_ACTIVITY') {
        //活动功能加载计数器
        appcan.window.evaluateScript({
            name : '',
            scriptContent : 'setShowInterval(' + result.activityIsStart + ',' + result.activityTime + ',\"' + result.activityMsg + '\");'
        });

        var activityTime = result.activityTime;
        if (activityTime && activityTime > 0 && activityTime < 1800000) {
            if (activityTime > 60000) {
                activityTime = 60000;
            }
            setTimeout(function() {
                page = 1;
                initPage();
            }, activityTime);
        }

        if (result.activityIsStart == 0) {
            optionBtns = ["加入收藏", "未开始"];
            canAddShopping = false;
        } else if (result.activityIsStart == 2) {
            optionBtns = ["加入收藏", "抢光啦"];
            canAddShopping = false;
        }
    } else if (pageParam.method == 'B2B_COLLECT') {
        optionBtns[0] = "取消收藏";
    } else if (pageParam.method == 'B2B_RECOMMEND_PUR') {
        var ordertabs = [];
        //4.0
        if (user && user.isOnline && optionBtns.indexOf('购进查询') == -1) {
            optionBtns.push('购进查询');
        }

    }

    if (data && data.length > 0) {
        var render = appcan.view.template(temp.prod),
            noPic = LocStorage.get('noPic');

        if ((user.institutionType == 1 || user.institutionType == 2) && pageParam.method == 'B2B_INSTITUTION') {
            render = appcan.view.template(temp.prod_institution);
        }

        var showData = [];
        $.each(data, function(index, item) {
            if (!item.orgMerchandiseCode) {
                return;
            }
            var code = item.orgMerchandiseCode.substr(0, 10);
            //item.src = imagePath + code + '/' + code + '_s.JPG';
            item.src = imagePath + code + '/' + code + '.JPG';
            prodData.push(item);

            var html = $(render(item));
            //无图模式
            if (noPic == 'true') {
                html.addClass('nopic');
                var img = html.find('.img');
                html.find('.store').parent().append(img.find('.flag_price'));
                img.remove();
            } else {
                html.addClass('list');
            }
            html = html[0].outerHTML;

            var itemcon;
            if (result.isCart == '0') {
                itemcon = {
                    data : item,
                    title : html
                };

            } else {
                var style = [{
                    background : "#eeeeee",
                    color : '#666666',
                    padding : '0 0.5em',
                }, {
                    background : "#ff3300",
                    padding : '0 0.5em',
                }, {
                    background : "rgb(252,209,10)",
                    padding : '0 0.5em',
                }];

                if (optionBtns[1] != '加入购物车') {
                    style[1] = {
                        background : "#B7B7B7",
                        color : '#666666',
                        padding : '0 0.5em',
                    };
                }

                //prodShowData.push({
                itemcon = {
                    data : item,
                    content : html,
                    hideOption : {
                        content : optionBtns,
                        style : style,
                        onClick : function(e, index, length) {
                            var li = $(e.currentTarget).parents('li'),
                                lv_data = li[0].lv_data,
                                data = lv_data.data;

                            if (index == 0) {
                                if (pageParam.method == 'B2B_COLLECT') {
                                    removeCollect(data);
                                } else {
                                    addCollect(data);
                                }
                            } else if (index == 1) {
                                addShoppingCart(data);
                            } else if (index == 2) {
                                open({
                                    name : 'ProdSaleHistory',
                                    data : 'ProdSaleHistory.html?merchandiseId=' + data.merchandiseId + '&orgMerchandiseCode=' + data.orgMerchandiseCode + '&merchandiseName=' + data.merchandiseName + '&merchandiseSpec=' + data.merchandiseSpec + '&manufacturer=' + data.manufacturer
                                });
                            }
                        }
                    },
                }

                if (item.isEnd == '1') {
                    itemcon.hideOption.content = ["加入收藏", "已售罄"];
                    itemcon.hideOption.style[1] = {
                        background : "#B7B7B7",
                        color : '#666666',
                        padding : '0 0.5em',
                    };
                }
            }
            showData.push(itemcon);
        });
        if (page == 1) {
            ol.set(showData);
        } else {
            ol.add(showData, 1);
        }

        //处理手机未及时显示的问题
        var interval = setInterval(function() {
            if ($('#viewol>ul>li').last()[0] && $('#viewol>ul>li').last()[0].lv_data.data.merchandiseId == data[data.length - 1].merchandiseId) {
                $('#viewol>ul>li').css('borderBottom', '0');
                clearInterval(interval);
            }
        }, 20);
    } else {
        ol.set([]);
    }
}
/**
 * 商品单元格加载
 */
var loadCell = function(data) {
    if (data && data.length > 0) {
        var render = appcan.view.template(temp.prod),
            showData = [];
        $.each(data, function(index, item) {
            var code = item.orgMerchandiseCode.substr(0, 10);
            item.src = imagePath + code + '/' + code + '.JPG';

            var html = $(render(item));
            html.addClass('tab uhide');
            html.find('.store').parent().addClass('ub-ver').removeClass('ub-ac').append(optionBtnsHtml);
            prodData.push(item);
            html = html[0].outerHTML;
            showData.push({
                title : html,
                data : item
            });
        });
        var top = $(window).scrollTop();

        if (page == 1) {
            lv.set(showData);
        } else {
            lv.add(showData, 1);
        }

        //处理手机未及时显示的问题
        var interval = setInterval(function() {
            if ($('li').last()[0] && $('li').last()[0].lv_data.data.merchandiseId == data[data.length - 1].merchandiseId) {
                cellPlay($('li').last().parent().children());
                if (page != 1) {
                    $(window).scrollTop(top);
                }
                clearInterval(interval);
            }
        }, 20);

    } else {
        lv.set([]);
    }
}
/*
 * 商品单元格顯示
 */
var cellPlay = function(lis) {
    if (lis.length > 0) {
        var parent,
            parentul = $('#viewlv ul:last-child');
        $.each(lis, function(index, li) {
            li = $(li);
            if (index % 2 == 0) {
                if (parent) {
                    parent.find('.tab').removeClass('uhide');
                }
                parent = $('<div class="ub"></div>');
                parentul.append(parent);
            }
            li.addClass('ub-f1');

            parent.append(li);
        });
        if (parent) {
            parent.find('.tab').removeClass('uhide');
        }

        var childrenCount = parent.children().length;
        if (childrenCount < 2) {
            for (var i = 0,
                len = 2 - childrenCount; i < len; i++) {
                parent.append('<li class=" ub ub-f1"></li>');
            }
        }
        $('li[data-index]').css('width', 0);

        $('#viewlv').removeClass('uhide');
        $('img').parent().css('height', $($('img')[0]).offset().width + 'px');
    }
}
/**
 *加入购物车
 * @param {Object} prod
 */
var addShoppingCart = function(prod) {
    var param = {
        merchandiseId : prod.merchandiseId,
        isDecimal : prod.isDecimal,
        retail : prod.retail,
        middlingPacking : prod.middlingPacking,
        lowestAmount : prod.lowestAmount,
        highestAmount : prod.highestAmount,
        callback : 'successAddCart',
        winName : 'ProdList',
        popName : 'content',
    };

    editCart.show(param);
}
//加入购物车内成功后的回调
var successAddCart = function(result) {
    if (result.message || result.permission) {
        toast.show(result.message || result.permission || '', 2000);
    } else if (!result.success) {
        alert('添加购物车异常情况！请联系管理员！');
    }
}