var imagePath;

//订单初始总额
var init_totalPrice = 0;
//订单初始品种数，普通商品算一种，整个组合算一种
var init_cartAmount = 0;
// 普通商品数量
var listLen = 0;
//限购类不可勾选的异常商品数量
var exceptAmount = 0;
//组合数量
var groupListLen = 0;
//记录当前被修改数量的商品的原始采购数
var oldNum = 1;

//记录列表图片模式--有图or无图
var noPic = (LocStorage.get('noPic') === 'true' ? true : false);

var currentProduct;
var currentGroup;
var productData;
var groupData;
var productLv;
var groupLv;
//记录页面请求购物车后获得的数据，供切换列表图片显示模式时使用
var Result;

//记录每个精品组合的加入购物车时的MerchandiseId等对象数组，绑定到各个组合的数量框上，便于加入购物车传参
var groupMerchandiseIds = [];

var pageIndex = 1,
    pageSize = 20,
    currentList;

appcan.ready(function() {
    if (isPhone) {
        uexWindow.setMultilPopoverFlippingEnbaled(1);
    }
    $('#total').click(checkAll).prop('disabled', true);
    $('#order').click(orderClick).prop('disabled', true);
    updatePage(true);
});

//加载/更新页面
function updatePage(isInBack) {
    noPic = (LocStorage.get('noPic') === 'true' ? true : false);
    init_totalPrice = 0;
    init_cartAmount = 0;
    listLen = 0;
    groupListLen = 0;
    exceptAmount = 0;
    $('#total').prop('disabled', true);
    $('#order').prop('disabled', true);
    var runinBackground = isInBack || false;
    AjaxFn(urls.CART_GET, '', initPage, {
        timeout : 60 * 1000,
        runinBackground : runinBackground
    });
}

function initPage(result) {
    var dataObj = result[0];
    Result = dataObj;
    imagePath = global.imghost + dataObj.merchandiseImagePath;
    
    $('#cart').empty();
    $('#tips').remove();
    $('#groupbox').empty();
    $('#totalPrice').html(0);
    init_totalPrice = 0;

    var list = dataObj.list;
    if (list) {
        listLen = list.length;
        $.each(list, function(index, item) {
            //全选总价控制写在这里
            if (item.xgState && item.xgState == 1) {
                exceptAmount++;
                return true;
            }
            init_totalPrice = Number.FloatAdd(init_totalPrice, item.rowPrice);
        });
    }
    if (dataObj.groupList) {
        groupListLen = dataObj.groupList.length;
    }
    init_cartAmount = listLen + groupListLen - exceptAmount;

    if (!(init_cartAmount + exceptAmount)) {
        $('#cart').before('<div id="tips"> <div class="fa fa-2x fa-shopping-cart tc-m"></div><div> 购物车空空如也 </div><div> 去添加商品吧！</div> </div>');
        $('#bottom').addClass('uhide');
    } else {
        $('#tips').remove();
        $('#bottom').removeClass('uhide');
    }

    fulfillPage(dataObj);
    fulfillGroup(dataObj);
    checkLoadDone();
    $('#total').prop('disabled', false);
    $('#order').prop('disabled', false);
    $('#total').prop('checked', false);

}

//切换页面的图片显示模式
function changePicMode() {
    $('#total').prop('disabled', true);
    $('#order').prop('disabled', true);
    $('input').prop('checked', false);
    $('#totalPrice').html(0);
    $('#cart').empty();
    noPic = (LocStorage.get('noPic') === 'true' ? true : false);
    fulfillPage(Result);
    checkLoadDone(1);
    $('#total').prop('disabled', false);
    $('#order').prop('disabled', false);
}

//填充页面中商品信息和绑定每条数据相关事件
function fulfillPage(result) {
    pageIndex = 1;

    pagelist(result.list, pageIndex, pageSize, loadData);
}

//填充组合信息
function fulfillGroup(result) {
    groupData = [];
    var groupList = result.groupList;
    if (!groupList) {
        return;
    }

    var content = $('#groupbox');
    var groupRender = appcan.view.template($('#groupItem').html());

    $.each(groupList, function(index, groupItem) {
        groupItem.unitPrice = Number.FloatDivision(groupItem.groupPrice, groupItem.acitivytGroupNum);

        var groupCon = groupRender({
            groupItem : groupItem
        });
        groupData.push({
            data : groupItem,
            content : groupCon,
            hideOption : {
                content : ["&nbsp&nbsp&nbsp删除&nbsp&nbsp&nbsp"],
                style : {
                    background : "red",

                },
                onClick : function(e, index, length) {
                    eventStop(e);
                    appcan.window.confirm({
                        title : '注意',
                        content : '您确认要删除该商品么？',
                        buttons : ['确定', '取消'],
                        callback : function(err, data, dataType, optId) {
                            if (err) {
                                alert('确认框发生错误！');
                                return;
                            }
                            if (data == 0) {
                                deleteGroup(groupItem.cartIds, groupItem.groupId);
                            }
                        }
                    });
                },
                onLongTap : function(e, index) {
                }
            }
        });
    });

    groupLv = appcan.optionList({
        selector : "#groupbox",
        type : "hiddenLine",
        duration : "300ms",
        multiShow : false
    });
    groupLv.set(groupData);
}

//分步加载商品信息
var loadData = function(list, page, hasNextPage, listAll) {
    //log('填充购物车商品信息:' + page);

    var render = appcan.view.template($('#product').html()),
        content = $('#cart'),
        productData = [];

    $.each(list, function(index, item) {
        var code = item.merchandiseVo.orgMerchandiseCode.substr(0, 10);
        item.imgsrc = imagePath + code + "/" + code + ".JPG";
        var html = render(item);

        productData.push({
            data : item,
            content : html,
            hideOption : {
                content : ["&nbsp&nbsp&nbsp删除&nbsp&nbsp&nbsp"],
                style : {
                    background : "red",

                },
                onClick : function(e, index, length) {
                    eventStop(e);
                    appcan.window.confirm({
                        title : '注意',
                        content : '您确认要删除该商品么？',
                        buttons : ['确定', '取消'],
                        callback : function(err, data, dataType, optId) {
                            if (err) {
                                alert('确认框发生错误！');
                                return;
                            }
                            if (data == 0) {
                                currentProduct = item.merchandiseVo.merchandiseId;
                                deleteCart(item.cartId);
                            }
                        }
                    });

                },
                onLongTap : function(e, index) {

                }
            }
        })
    });

    if (page == 1) {
        productLv = appcan.optionList({
            selector : "#cart",
            type : "hiddenLine",
            duration : "300ms",
            multiShow : false
        });
        productLv.set(productData);
        productLv.on("click", function(ele, obj, curEle) {
            if (curEle.hasClass('policy-detail') || curEle.hasClass('limit')) {
                $(curEle).toggleClass('ut-s');
            } else {
                openDetail(obj.data.merchandiseId);
            }

        });

    } else {
        productLv.add(productData, 1);
    }
    currentList = list;
    if (hasNextPage) {
        pageIndex++;
        var interval = setInterval(function() {
            if (productLv.ele.find('li').last()[0] && productLv.ele.find('li').last()[0].lv_data.data.merchandiseId == currentList[currentList.length - 1].merchandiseId) {
                pagelist(listAll, pageIndex, pageSize, loadData);
                clearInterval(interval);
            }
        }, 200);

    }
}
//检测页面是否加载完全，绑定事件，onlyList boolean,标识只检测和绑定普通商品
function checkLoadDone(onlyList) {
    //log("检测页面加载完全");
    if (listLen > 0) {
        var time = 0;
        var interval = setInterval(function() {
            var productBoxes = $('#cart [type="selfinput"]');
            var length = productBoxes.length;

            time += 100;

            if (length == listLen) {
                clearInterval(interval);
                //log("绑定事件");
                productBoxes.bind('tap', openEditBox);
                $('#cart input[name="product"]').bind('change', checkChange);

            } else if (time == 1000 * 60 * 1) {
                clearInterval(interval);
                //log("不正常绑定");
                productBoxes.bind('tap', openEditBox);
                $('#cart input[name="product"]').bind('change', checkChange);
            }
        }, 100);
    }
    if (groupListLen > 0 && !onlyList) {
        var interval2 = setInterval(function() {
            var groupEditBoxes = $('#groupbox [type="selfinput"]');
            var length = groupEditBoxes.length;
            //log('cart detail count' + length);
            if (length == groupListLen) {
                clearInterval(interval2);

                $('.detail').bind('click', function(e) {
                    var obj = e.currentTarget;
                    obj = $(obj);
                    var merchandiseId = obj.attr('id');
                    openDetail(merchandiseId);
                });
                $('#groupbox input[name="product"]').bind('change', checkChange);

                $.each(groupEditBoxes, function(index, item) {
                    item = $(item);
                    item.attr('cartId', JSON.stringify(groupMerchandiseIds[index]));
                    item.bind('tap', openGroupEditBox);
                });

            }
        }, 100);
    }
}

//打开商品的详情
function openDetail(merchandiseId) {
    open({
        name : 'ProdDetails_EC',
        data : 'ProdDetails_EC.html?from=cart&merchandiseId=' + merchandiseId
    });

}

//删除普通商品操作
var deleteCart = function(cartId) {
    //log('开始删除');
    var deleteparam = {
        cartId : cartId,
    };
    //console.log('deleteparam' + JSON.stringify(deleteparam));
    AjaxFn(urls.CART_DELETE, deleteparam, function(result) {

        //商品删除成功，则直接去掉本页面中的该商品，重新计算其他数据，不刷新整个购物车数据
        if (result.success == 'true') {
            var product = $('#' + currentProduct);
            var root = product.parents('.bc-bg-white');
            //限购的异常商品，删除后只修改exceptAmount数据，无需更新总价、总条目数等，因为未计入
            if (root.find('input').attr('disabled') == true) {
                exceptAmount--;
            } else {
                var difference = parseFloat(root.find('.rowPrice').html());
                init_totalPrice = Number.FloatSubt(init_totalPrice, difference);
                var inputCheck = root.find('input[name="product"]').attr('checked');

                if (inputCheck) {
                    var totalPrice = parseFloat($('#totalPrice').html());
                    totalPrice = Number.FloatSubt(totalPrice, difference);
                    $('#totalPrice').html(totalPrice);
                }
                init_cartAmount--;
            }

            root.parents('li').remove();
            if (!(init_cartAmount + exceptAmount)) {
                $('#cart').empty();
                $('#groupbox').empty();
                $('#cart').before('<div id="tips"> <div class="fa fa-2x fa-shopping-cart tc-m"></div><div> 购物车空空如也 </div><div> 去添加商品吧！</div> </div>');
                $('#bottom').addClass('uhide');
            }
            //刷新购物车数量角标
            appcan.window.evaluateScript({
                name : 'B2BApp',
                scriptContent : 'getCartNum();'
            });
            //更新本页面中的Result，以免切换图片显示模式时，有图和无图的数据不一致
            AjaxFn(urls.CART_GET, '', function(result) {
                Result = result[0];
                listLen = Result.list.length || 0;
            }, {
                timeout : 60 * 1000,
                runinBackground : true
            });
        } else {
            var msg = result.message || result.msg || '删除失败！';
            if (msg) {
                toast.show(msg, 2000);
                updatePage();
            }
        }
    });
};

//删除组合操作
var deleteGroup = function(cartIds, groupId) {
    var deleteparam = {
        cartId : cartIds,
    };
    //console.log('deleteparam' + JSON.stringify(deleteparam));
    AjaxFn(urls.CART_DELETE, deleteparam, function(result) {
        //组合删除成功，则直接去掉本页面中的该组合，重新计算其他数据，不刷新整个购物车数据
        if (result.success == 'true') {
            var root = $('#group' + groupId);
            var difference = parseFloat(root.find('.rowPrice').html());
            init_totalPrice = Number.FloatSubt(init_totalPrice, difference);
            var inputCheck = root.find('input[name="product"]').attr('checked');

            if (inputCheck) {
                var totalPrice = parseFloat($('#totalPrice').html());
                totalPrice = Number.FloatSubt(totalPrice, difference);
                $('#totalPrice').html(totalPrice);
            }
            init_cartAmount--;
            root.parents('li').remove();
            if (!init_cartAmount) {
                $('#cart').empty();
                $('#groupbox').empty();
                $('#cart').before('<div id="tips"> <div class="fa fa-2x fa-shopping-cart tc-m"></div><div> 购物车空空如也 </div><div> 去添加商品吧！</div> </div>');
                $('#bottom').addClass('uhide');
            }
            appcan.window.evaluateScript({
                name : 'B2BApp',
                scriptContent : 'getCartNum();'
            });
        } else {
            var msg = result.message || result.msg || '删除失败！';
            if (msg) {
                toast.show(msg, 2000);
            }
            updatePage();

        }
    });
}
//调出购物车数量编辑窗口
function openEditBox(e) {
    //log('调出购物车数量编辑窗口');
    eventStop(e);
    var merchandiseId = parseInt($(this).attr('id'));
    var num = $(this).text().trim();
    num = num.replace(/\n/g, '');
    oldNum = parseFloat(num);
    currentProduct = merchandiseId;
    var para = {
        merchandiseId : merchandiseId,
        oldNum : num,
        winName : 'B2BApp',
        popName : 'content',
        inPageName : 'content_2',
        callback : 'updateNum',
        isDecimal : $(this).attr('isDecimal'),
        middlingPacking : $(this).attr('middlingPacking'),
        retail : $(this).attr('retail'),
        highestAmount : $(this).attr('highestAmount'),
        lowestAmount : $(this).attr('lowestAmount'),
        isUpdate : true
    }
    editCart.show(para);
}

//调出组合购物车数量编辑窗口
function openGroupEditBox(e) {
    eventStop(e);
    var num = $(this).text().trim();
    num = num.replace(/\n/g, '');
    oldNum = parseFloat(num);
    currentGroup = $(this).attr('groupId');
    var para = {
        oldNum : num,
        winName : 'B2BApp',
        popName : 'content',
        inPageName : 'content_2',
        callback : 'updateGroupNum',
        group : JSON.parse($(this).attr('cartId')),
        isUpdate : true,
        groupLowData : JSON.parse($(this).attr('groupLowData')),
        groupHighData : JSON.parse($(this).attr('groupHighData')),
    }
    editCart.show(para);
}

//修改商品数量后，更新本页购物车数量
function updateNum(result, newNum) {
    if (result.message) {
        toast.show(result.message, 2000);
    }
    //商品数量更新成功，则直接更新本页面中商品的数量和其他数据，不刷新整个购物车数据
    if (result.success && result.success == 'true') {
        var product = $('#' + currentProduct);
        var root = product.parents('.bc-bg-white');
        var input = root.find('input');
        var xgState = input.attr("xgState");
        if ((xgState == 0 || xgState == '0') && newNum) {
            newNum = parseFloat(newNum);
            product.html(newNum);
            var price = parseFloat(root.find('.price').html());
            //如果商品价格因价格策略有变化，更新页面中的该商品价格
            if (result.newCartVoList && result.newCartVoList.length > 0) {
                var newPrice = result.newCartVoList[0].merchandiseVo.formatMermberPrice || price;
                if (parseFloat(newPrice) != price) {
                    root.find('.price').html(newPrice);
                    root.find('.fm_price').html(newPrice);
                    price = newPrice;
                }
            }
            var oldRowPrice = parseFloat(root.find('.rowPrice').html());
            var newRowPrice = Number.FloatMult(newNum, price);
            root.find('.rowPrice').html(newRowPrice);
            //限购商品无需更新购物车总价，因为不计入总价
            var isBanned = input.attr('disabled');
            if (isBanned) {
                return;
            }
            var difference = Number.FloatSubt(newRowPrice, oldRowPrice);
            init_totalPrice = Number.FloatAdd(init_totalPrice, difference);
            var inputCheck = root.find('input[name="product"]').attr('checked');
            if (inputCheck) {
                var totalPrice = parseFloat($('#totalPrice').html());
                totalPrice = Number.FloatAdd(totalPrice, difference);
                $('#totalPrice').html(totalPrice);
            }
        } else {
            setTimeout('updatePage();', 200);
            //缺失新数量时，更新整个购物车。如果立即执行更新，有时返回的购物车数据会出现数量并没有更新的情况，可能有延迟。
            $('#totalPrice').html(0);
            $('#total').prop('disabled', true);
            $('#order').prop('disabled', true);
        }
    }
}

//修改组合数量后，更新本页购物车数量
function updateGroupNum(result, newNum) {
    //log('进入updateNum');
    //log(result);
    if (result.message) {
        toast.show(result.message, 2000);
    }
    //商品数量更新成功，则直接更新本页面中商品的数量和其他数据，不刷新整个购物车数据
    if (result.success && result.success == 'true') {
        if (newNum) {
            newNum = parseFloat(newNum);
            var group = $('#group' + currentGroup);
            var groupNumbox = group.find('.purchaseAmount');
            groupNumbox.html(newNum);
            var root = group;
            var price = parseFloat(root.find('.price').html());
            var oldRowPrice = parseFloat(root.find('.rowPrice').html());
            var newRowPrice = Number.FloatMult(newNum, price);
            root.find('.rowPrice').html(newRowPrice);
            var difference = Number.FloatSubt(newRowPrice, oldRowPrice);
            init_totalPrice = Number.FloatAdd(init_totalPrice, difference);
            var inputCheck = root.find('input[name="product"]').attr('checked');
            if (inputCheck) {
                var totalPrice = parseFloat($('#totalPrice').html());
                totalPrice = Number.FloatAdd(totalPrice, difference);
                $('#totalPrice').html(totalPrice);
            }
        } else {
            setTimeout('updatePage();', 200);
            //缺失新数量时，更新整个购物车。如果立即执行更新，有时返回的购物车数据会出现数量并没有更新的情况，可能有延迟。
            $('#totalPrice').html(0);
            $('#total').prop('disabled', true);
            $('#order').prop('disabled', true);
        }
    }
}

//点击下单
function orderClick() {

    var cartIds = new Array();
    var carts = $('input[name="product"]:checked');
    var num = carts.length;
    if (num == 0) {
        alert('请选择要下单的商品！');
        return;
    }
    $.each(carts, function(i, cart) {
        var id = $(cart).attr('id');
        cartIds.push(id);
    });

    cartIds = cartIds.join(',');

    var paramdata = {
        order : cartIds,
        notes : '',
        orderAmountPrice : $('#totalPrice').html() || 0
    };
    //console.log('下单：' + JSON.stringify(paramdata));
    AjaxFn(urls.ORDER_SURE, paramdata, function(result) {
        //console.log('下单确认：');
        var msg = result.msg || result.msgInfo || result.message;
        if (msg) {
            toast.show(msg, 2000);
        }
        var order_sure_data = JSON.stringify(result);
        LocStorage.set('order_sure_data', order_sure_data);
        open({
            name : 'OrderConfirm',
            data : 'OrderConfirm.html'
        });

    }, {
        timeout : 5 * 60 * 1000,
        successException : function(result) {
            var msg = result.msg || result.msgInfo || result.message || '';
            if (msg) {
                toast.show(msg, 5000);
            }
            updatePage();
            appcan.window.evaluateScript({
                name : 'B2BApp',
                scriptContent : 'getCartNum();'
            });
        },
        loadView : true
    });
}

//检测总计选中或取消，全选或全取消操作
function checkAll(e) {
    // eventStop(e);
    //log('进入检测全选');

    if ($(this).attr('checked') == true) {
        //log('全选按钮为选中');
        $('input[name="product"]').each(function(index, item) {
            item = $(item);
            if (!item.attr('disabled')) {
                item.prop('checked', true);
            }
        });
        if (exceptAmount) {
            toast.show("购物车中存在超过限购条件的商品，其下单时无法进入订单！", 2000);
        }
        $('#totalPrice').html(init_totalPrice);
    } else {
        //log('全选按钮为取消');
        $('input[name="product"]').prop('checked', false);
        $('#totalPrice').html(0);
    }
}

//检测每个药品是选中或还是取消选中，执行总价更新等操作
function checkChange(e) {
    //e.stopPropagation();
    //log('进入检测每个按钮');
    if ($(this).attr('checked') == true) {
        modifyData($(this), '+');
        //log('按钮值为真');
        var carts = $('input[name="product"]:checked');
        if (carts.length == init_cartAmount) {

            $('#total').prop('checked', true);
            if (exceptAmount) {
                toast.show("购物车中存在超过限购条件的商品，其下单时无法进入订单！", 2000);
            }
        }

    } else {
        //log('按钮值为假');
        modifyData($(this), '-');
        $('#total').prop('checked', false);
    }
}

//根据被选中或取消选中的对象obj,参数para(为'+'或'-')，修改总计、种类、数量的数值。
function modifyData(obj, para) {
    var totalPrice = parseFloat($('#totalPrice').html());
    var root = obj.parents('.bc-bg-white');
    var rowPrice = parseFloat(root.find('.rowPrice').html());
    if (para == '+') {
        totalPrice = Number.FloatAdd(totalPrice, rowPrice);
    }
    if (para == '-') {
        totalPrice = Number.FloatSubt(totalPrice, rowPrice);
    }
    $('#totalPrice').html(totalPrice);

}

